<template>
	<view>
		<headNav idIndex="1" text="中医人物数据库" />
		<!-- 高级搜索 -->
		<view style="margin: .35rem 0 .16rem 0; ">
			<advancedSearch @onSearch="onSearch" @onSubmit="onSubmit" :from="From" placehold="输入姓名/别名/朝代/传主职业搜索" />
		</view>
		<!-- 热门搜索 -->
		<view class="flex flex-center hotSearch">
			热门搜索：
			<ul class="flex" style="margin-right: 10rpx;">
				<li @click="dynastyBottomClick(item)" class="cursor" v-for="item in hot" :key="item.id" style="">
					{{item.name}}
				</li>
			</ul>
		</view>
		<view class="" style="margin-left: .2rem;">书中最常提到的100位人物</view>
		<!-- 关系表地图 -->
		<view id="relation" style="margin-top: .2rem; height: 70vh;width: 100%;"></view>
		<!-- 朝代 -->
		<view class="flex flex-center" style="width: 100%; position: fixed;bottom: .33rem;left: 0;">
			<ul class="flex">
				<li @click="dynastyBottomClick(item)" v-for="(item,index) in dynasty" :key="item.id">
					<view class="flex flex-center" style="height: .35rem; background-color: #fff; color:#244A7B ;">
						{{item.coord}}
					</view>
					<view class="flex flex-center font-family"
						style="padding: .05rem .19rem; height: .3rem;line-height: .3rem; color: #fff; font-size: .14rem; margin-top: .03rem;margin-right: .03rem;background-color: #597AA5;"
						:style="{'marginRight': index === dynasty.length - 1 ? '0' : '0.03rem','background':dynastyColor==item.id?'#244A7B':'#597AA5'}">
						{{item.name}}
					</view>
				</li>
			</ul>
		</view>
	</view>
</template>

<script>
	import {
		getDataStatistics,
		getHotSearch,
		getFuzzySearch,
		getAdvanceSearch,
		getPDataStatistics
	} from '@/api/index.js'
	import * as echarts from 'echarts';
	export default {
		data() {
			return {
				// echarts数据
				nodes: [{
					name: '李时珍',
					id: 23
				}],
				// echarts两者的关系
				relationships: [{
						source: '李时珍',
						target: '成就',
						relation: '好友'
					},
					{
						source: '李时珍',
						target: '传承',
						relation: '好1友'
					},
					{
						source: '李时珍',
						target: '亲友',
						relation: '好2友'
					},
					{
						source: '李时珍',
						target: '著作',
						relation: '好2友'
					},
					// 其他关系...
				],
				// 高级搜索
				From: {
					from: [{
						type: 'input',
						label: '姓名',
						name: 'name',
						value: ''
					}, {
						type: 'input',
						label: '别名',
						name: 'alias',
						value: ''
					}, {
						type: 'input',
						label: '籍贯',
						name: 'location',
						value: ''
					}, {
						type: 'select',
						label: '职业',
						name: 'sdId',
						value: '',
						options: [{
							label: '未指明',
							value: 'UNKNOWN'
						}, ]
					}, {
						type: 'input',
						label: '官职',
						name: 'office',
						value: ''
					}, {
						type: 'select',
						label: '性别',
						value: '',
						name: 'genderTypeEO',
						options: [{
								label: '未指明',
								value: 'UNKNOWN'
							}, {
								label: '男',
								value: 'MALE'
							},
							{
								label: '女',
								value: 'WOMAN'
							}
						]
					}, {
						type: 'input',
						label: '时间',
						name: 'period',
						value: ''
					}, {
						type: 'input',
						label: '机构',
						name: 'inst',
						value: ''
					}, {
						type: 'number',
						label: '页码',
						name: 'page',
						value: ''
					}, {
						type: 'number',
						label: '页大小',
						name: 'pageSize',
						value: ''
					}, ]
				},
				// 下面的朝代1
				dynastyColor: 1,
				// 朝代
				dynasty: [{
						name: '夏朝',
						coord: '2070BC',
						id: 1
					},
					{
						name: '商朝',
						id: 2,
						coord: '1600BC',
					},
					{
						name: '西周',
						id: 3,
						coord: '1600BC'
					},
					{
						name: '春秋战国',
						id: 4,
						coord: '770BC'
					},
					{
						name: '秦朝',
						id: 5,
						coord: '221BC'
					},
					{
						name: '汉朝',
						id: 6,
						coord: '202BC'
					},
					{
						name: '三国两晋南北朝',
						id: 7,
						coord: '184'
					},
					{
						name: '隋朝',
						id: 8,
						coord: '581'
					},
					{
						name: '唐朝',
						id: 9,
						coord: '618'
					},
					{
						name: '五代十国',
						id: 10,
						coord: '907'
					},
					{
						name: '辽夏金',
						id: 11,
						coord: '907'
					},
					{
						name: '宋朝',
						id: 12,
						coord: '960'
					},
					{
						name: '元朝',
						id: 13,
						coord: '1271'
					},

					{
						name: '明朝',
						id: 14,
						coord: '1368'
					},
					{
						name: '清朝',
						id: 15,
						coord: '1636'
					}
				],
				// 热门搜索
				hot: [{
						id: 1,
						name: '李时珍',
						bgColor: false
					},
					{
						id: 2,
						name: '李时珍2',
						bgColor: false
					},
					{
						id: 3,
						name: '李时珍3',
						bgColor: false
					},
				],
			}
		},

		methods: {
			// 关系图谱
			relation() {
				var chartDom = document.getElementById('relation');
				var myChart = echarts.init(chartDom);
				// 假设您有节点名称和它们之间的关系数据
				var nodes = this.nodes;
				var relationships = this.relationships

				let FontSize = 12; // 字体大小
				let BorderWidth = 2; // 边框大小
				let SymbolSize = 80; // 尺寸距离
				let Distance = 10
				// 不同尺寸下修改echarts的字体
				if (window.innerWidth > 2560 && window.innerWidth <= 3840) {
					FontSize = 28
					BorderWidth = 5
					SymbolSize = 100
					Distance = 33
				} else if (window.innerWidth > 1920 && window.innerWidth <= 2560) {
					FontSize = 28
					BorderWidth = 4
					SymbolSize = 90
					Distance = 22
				} else if (window.innerWidth >= 1366 && window.innerWidth <= 1920) {
					FontSize = 18
					BorderWidth = 4
					SymbolSize = 70
					Distance = 22
				}
				// 根据关系数据生成连接线
				var links = [];
				relationships.forEach((relationship, i) => {
					// 靳
					var sourceIndex = nodes.findIndex((node) => node.name === relationship.source);
					var targetIndex = nodes.findIndex((node) => node.name === relationship.target);
					if (relationship.relation) {
						if (sourceIndex !== -1 && targetIndex !== -1) {
							console.log(relationship.source, relationship.target);
							links.push({
								source: sourceIndex,
								target: targetIndex,
								label: {
									show: true,
									formatter: function(params) { // 使用函数动态生成标签内容
										// console.log(params, 'paramsparamsparamsparamsparams');
										// return relationships.find(rel => rel.source === nodes[params.data
										// 		.source] && rel.target === nodes[params.data.target])
										// 	.relation;
										return relationship.relation;
									}, // 设置关系标签内容为"Child-Parent"
									color: '#2C2C2C',
									fontSize: FontSize - 2,
									backgroundColor: 'rgba(255, 255, 255, 1)',
									padding: [3, 8],
									borderRadius: 30,
									position: 'middle', // 设置标签文本在线的中间位置上居中显示
									// bottom: -(FontSize+10),
									z: 10, // 设置标签的z轴高度，使其比连接线更高
									// offset: [0, 15] ,// 往下移动 10 像素
									distance: -(Distance + 1), // 将标签放置在连接线上
								}
							});
						}
					}
				});
				// 根据nodes动态生成节点数据
				var nodeData = nodes.map(function(node, index) {
					return {
						name: node.name,
						id: node.id,
						x: Math.random() * 2000, // 设置随机x坐标位置
						y: Math.random() * 600, // 设置随机y坐标位置
						itemStyle: {
							color: getColorByIndex(), // 可以根据索引设置不同的颜色
							borderWidth: BorderWidth,
							borderColor: getColorByIndex()
						}
					};
				});
				// 设置颜色
				function getColorByIndex() {
					     // 生成随机的 R、G、B 分量值，限制在更高的范围内
					        var r = Math.floor(Math.random() * 106) + 150; // 150 到 255 之间的随机数
					        var g = Math.floor(Math.random() * 106) + 150; // 150 到 255 之间的随机数
					        var b = Math.floor(Math.random() * 106) + 150; // 150 到 255 之间的随机数
					        // 将 R、G、B 分量值转换为十六进制，并确保每个分量值都是两位数
					        var hexR = r.toString(16).padStart(2, '0'); // 使用 padStart 方法确保生成的十六进制数为两位
					        var hexG = g.toString(16).padStart(2, '0');
					        var hexB = b.toString(16).padStart(2, '0');
					        // 拼接十六进制颜色值
					        var color = '#' + hexR + hexG + hexB;
					        return color;
				}
				var option;
				option = {
					title: {
						// text: '书中最常提到的100位人物',
						// subtext: '',
						left: 'center',
						top: FontSize + 10,
						// textStyle: {
						// 	fontSize: FontSize // 设置标题文字大小为 18px
						// },
						subtextStyle: {
							fontSize: FontSize, // 设置副标题文字大小为 14px
							color: '#2C2C2C'
						}
					},
					backgroundColor: {
						type: 'image',
						image: '/static/image/characterRelationBg.png',
						// repeat: 'repeat-x', // 是否平铺，可以是 'repeat-x', 'repeat-y', 'no-repeat'
						size: '100% 100%', // 背景图片的尺寸，可以是百分比或者像素
						position: 'center center' // 背景图片的位置，可以是 top, bottom, middle 或者百分比
					},
					tooltip: {},
					animationDurationUpdate: 1500,
					animationEasingUpdate: 'quinticInOut',
					series: [{
						type: 'graph',
						layout: 'none',
						symbolSize: SymbolSize, // 调整节点大小
						label: {
							show: true,
							color: 'black', // 设置节点文字颜色为黑色
							fontSize: FontSize, // 设置文字大小
						},
						edgeSymbol: ['circle'],
						edgeSymbolSize: [4, 10],
						data: nodeData,
						links: links,
						lineStyle: {
							opacity: 0.9,
							width: 2,
							curveness: 0.3
						}
					}]
				};
				// 将生成的连接线添加到echarts图表的option中
				option.series[0].links = links;
				// 设置点击事件监听
				myChart.on('click', (params) => {
					// menuNav2 = !menuNav1
					// console.log(params);
					if (params.componentType === 'series') {
						var dataName = params.data.name; // 获取点击的数据名称
						var dataValue = params.data.value; // 获取点击的数据值
						// 在这里可以根据需要处理点击事件，比如弹出对应数据的详细信息等操作
						// console.log('点击了', dataName, '数据，数值为', dataValue);
						// 这里可以编写触发时间获取对应数据信息的逻辑
						this.spaceTimeArr(params)
					}
				})
				option && myChart.setOption(option);
			},
			// 关系图 点击里面的元素
			spaceTimeArr(Arr) {
				// 关系图的数据
				console.log(Arr);
				uni.navigateTo({
					url: '/pages/repository/repository'
				})
			},
			// 获取朝代echarts的数据
			async echartsArr() {
				await getDataStatistics().then((res) => {
					console.log(res.object);
					res.object.dynastyStatistic.details.map((item, index) => {
						// this.dynasty.id = item.dynastyId
						// this.dynasty.name = item.dynastyName
						// this.dynasty.coord = item.count
						this.dynasty[index].id = item.dynastyId;
						this.dynasty[index].name = item.dynastyName;
						this.dynasty[index].coord = item.count;
					})
					console.log(this.dynasty, 'sdfsfd');
				})

			},
			// 热门搜索
			async hotSearch() {
				await getHotSearch().then(res => {
					console.log(res, 'saaadfds');
					this.hot = Object.keys(res.object).map(key => {
						return {
							id: parseInt(key),
							name: res.object[key]
						};
					})
					// this.hot = res.list
				})
			},
			// 基础搜索
			async onSearch(val) {
				console.log(val);
				await getFuzzySearch(val.text).then(res => {
					console.log(res, 'jieko');
					if (res.list) {
						this.nodes = []
						this.relationships = []
						res.list.forEach((item, index) => {
							let exists1 = this.nodes.some(node => (node.id === item.identifier1 && node
								.name === item.name1));
							let exists2 = this.nodes.some(node => (node.id === item.identifier2 && node
								.name === item.name2));
							// 证明不存在
							if (exists1 !== true) {
								this.nodes.push({
									name: item.name1,
									id: item.identifier1
								})
							}
							if (exists2 !== true) {
								this.nodes.push({
									name: item.name2,
									id: item.identifier2
								})
							}
							let obj = {
								source: item.name1,
								target: item.name2,
								relation: item.relationName ||
									'' // 如果存在 relationName 字段则使用，否则为空字符串
							}
							// 只有当 item.relationName 存在时，才向 obj 对象中添加 relation 字段
							if (item.relationName) {
								obj.relation = item.relationName;
							}
							this.relationships.push(obj)

						});
						// this.nodes = []
						// this.nodes[0] = {
						// 	name: res.list[0].name1,
						// 	id: res.list[0].identifier1
						// }
						// this.nodes[1] = {
						// 	name: res.list[1].name1,
						// 	id: res.list[1].identifier1
						// }
						// for (let i = 1; i < res.list.length; i++) {
						// 	let node1 = {
						// 		name: res.list[i].name1,
						// 		id: res.list[i].identifier1
						// 	}
						// 	this.nodes.push(node1);
						// 	// console.log(i);
						// }
						// this.nodes = [...new Set(this.nodes.map(node => JSON.stringify(node)))].map(node =>
						// 	JSON.parse(node));
						// 	console.log(this.nodes,'nodesnodesnodesnodes');
						// this.relationships = this.nodes.slice(1).map((item, index) => {
						// 	console.log(item,res.list[index].relationName, 'iiiiiiiiiiiiisdfdsf');
						// 	return {
						// 		source: this.nodes[0].name,
						// 		target: item.name,
						// 		relation: res.list[index].relationName
						// 	};
						// });
					} else {
						// alert('没有搜索到数据')
					}
					this.relation()
					console.log(res);

				})

			},
			// 高级搜索
			async onSubmit(val) {
				console.log(val);
				await getAdvanceSearch(val).then(res => {
					console.log(res, '接口调用成功');
				})
			},
			// 点击下面的朝代按钮
			dynastyBottomClick(item) {

				this.dynastyColor = item.id
				this.onSearch({
					text: item.name
				})
			},
			// 高级搜索里面职业的下拉菜单
			async innt() {
				await getPDataStatistics().then(res => {
					const professionIndex = this.From.from.findIndex(field => field.label === '职业');
					// 如果找到了职业字段
					if (professionIndex !== -1) {
						// 将 profession.list 转换为 options 格式
						const options = res.object.occupationStatistic.details.map(item => ({
							label: item.tagName,
							value: item.tagId.toString() // 将 id 转换为字符串，确保与 value 类型一致
						}));
						// 更新职业字段的 options 属性
						this.$set(this.From.from[professionIndex], 'options', options);
					}
				})
			}
		},
		mounted() {
			this.relation()
			this.echartsArr()
			this.hotSearch()
			this.onSearch({
				text: ''
			})
			// 监听窗口大小变化
			window.addEventListener('resize', this.relation);


			this.innt()
		}
	}
</script>

<style>
	@media screen and (min-width:2560px)and (max-width:3840px) {}

	@media screen and (min-width:1366px) and (max-width:1920px) {}

	::v-deep .uni-input-placeholder {
		line-height: 1;
		font-size: .12rem;
	}

	::v-deep .ffff {
		border-radius: .5rem;
	}

	::v-deep .widget_button {
		border-radius: .5rem;
		margin: .02rem;
	}

	.hotSearch {
		font-size: .12rem;
		color: #2C2C2C;

		li {
			color: #244A7B;
			margin: 0 .1rem;
			color: #244A7B;
		}
	}
</style>